#ifndef DEF_NON_COPYABLE_HPP
#define DEF_NON_COPYABLE_HPP

namespace pacpus
{
  /** NonCopyable
   * @brief Derive your own class from noncopyable when you want to prohibit copy construction and copy assignment.
   */
  class NonCopyable
  {
    protected:
      NonCopyable() {}
      ~NonCopyable() {}
      
    private:
      NonCopyable(NonCopyable const&);
      NonCopyable& operator=(NonCopyable const&);
  };
}

#endif
